'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _Object$keys = require('@babel/runtime-corejs3/core-js-stable/object/keys');
var _Object$getOwnPropertySymbols = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols');
var _filterInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/filter');
var _Object$getOwnPropertyDescriptor = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptor');
var _forEachInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/for-each');
var _Object$getOwnPropertyDescriptors = require('@babel/runtime-corejs3/core-js-stable/object/get-own-property-descriptors');
var _Object$defineProperties = require('@babel/runtime-corejs3/core-js-stable/object/define-properties');
var _Object$defineProperty = require('@babel/runtime-corejs3/core-js-stable/object/define-property');
var _defineProperty = require('@babel/runtime-corejs3/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime-corejs3/helpers/objectWithoutProperties');
var _trimInstanceProperty = require('@babel/runtime-corejs3/core-js-stable/instance/trim');
var utils = require('@commercetools-uikit/utils');
var Constraints = require('@commercetools-uikit/constraints');
var inputUtils = require('@commercetools-uikit/input-utils');
var jsxRuntime = require('@emotion/react/jsx-runtime');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var _Object$keys__default = /*#__PURE__*/_interopDefault(_Object$keys);
var _Object$getOwnPropertySymbols__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertySymbols);
var _filterInstanceProperty__default = /*#__PURE__*/_interopDefault(_filterInstanceProperty);
var _Object$getOwnPropertyDescriptor__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptor);
var _forEachInstanceProperty__default = /*#__PURE__*/_interopDefault(_forEachInstanceProperty);
var _Object$getOwnPropertyDescriptors__default = /*#__PURE__*/_interopDefault(_Object$getOwnPropertyDescriptors);
var _Object$defineProperties__default = /*#__PURE__*/_interopDefault(_Object$defineProperties);
var _Object$defineProperty__default = /*#__PURE__*/_interopDefault(_Object$defineProperty);
var _trimInstanceProperty__default = /*#__PURE__*/_interopDefault(_trimInstanceProperty);
var Constraints__default = /*#__PURE__*/_interopDefault(Constraints);

const _excluded = ["horizontalConstraint", "isDisabled", "isReadOnly", "isPasswordVisible"];
function ownKeys(e, r) { var t = _Object$keys__default["default"](e); if (_Object$getOwnPropertySymbols__default["default"]) { var o = _Object$getOwnPropertySymbols__default["default"](e); r && (o = _filterInstanceProperty__default["default"](o).call(o, function (r) { return _Object$getOwnPropertyDescriptor__default["default"](e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var _context, _context2; var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? _forEachInstanceProperty__default["default"](_context = ownKeys(Object(t), !0)).call(_context, function (r) { _defineProperty(e, r, t[r]); }) : _Object$getOwnPropertyDescriptors__default["default"] ? _Object$defineProperties__default["default"](e, _Object$getOwnPropertyDescriptors__default["default"](t)) : _forEachInstanceProperty__default["default"](_context2 = ownKeys(Object(t))).call(_context2, function (r) { _Object$defineProperty__default["default"](e, r, _Object$getOwnPropertyDescriptor__default["default"](t, r)); }); } return e; }
const PasswordInput = _ref => {
  let _ref$horizontalConstr = _ref.horizontalConstraint,
    horizontalConstraint = _ref$horizontalConstr === void 0 ? 'scale' : _ref$horizontalConstr,
    _ref$isDisabled = _ref.isDisabled,
    isDisabled = _ref$isDisabled === void 0 ? false : _ref$isDisabled,
    _ref$isReadOnly = _ref.isReadOnly,
    isReadOnly = _ref$isReadOnly === void 0 ? false : _ref$isReadOnly,
    _ref$isPasswordVisibl = _ref.isPasswordVisible,
    isPasswordVisible = _ref$isPasswordVisibl === void 0 ? false : _ref$isPasswordVisibl,
    props = _objectWithoutProperties(_ref, _excluded);
  if (!isReadOnly) {
    process.env.NODE_ENV !== "production" ? utils.warning(Boolean(props.onChange), 'PasswordInput: `onChange` is required when is not read only.') : void 0;
  }
  return jsxRuntime.jsx(Constraints__default["default"].Horizontal, {
    max: horizontalConstraint,
    children: jsxRuntime.jsx("input", _objectSpread(_objectSpread({
      id: props.id,
      name: props.name,
      type: isPasswordVisible ? 'text' : 'password',
      value: props.value,
      onChange: props.onChange,
      onBlur: props.onBlur,
      onFocus: props.onFocus,
      disabled: isDisabled,
      placeholder: props.placeholder,
      autoComplete: props.autoComplete,
      css: inputUtils.getInputStyles(_objectSpread({
        isDisabled,
        isReadOnly
      }, props)),
      readOnly: isReadOnly,
      autoFocus: props.isAutofocussed
    }, utils.filterDataAttributes(props)), {}, {
      /* ARIA */
      "aria-readonly": isReadOnly,
      contentEditable: !isReadOnly,
      "aria-invalid": props['aria-invalid'],
      "aria-errormessage": props['aria-errormessage']
    }))
  });
};
PasswordInput.displayName = 'PasswordInput';
PasswordInput.isEmpty = value => !value || _trimInstanceProperty__default["default"](value).call(value).length === 0;
var PasswordInput$1 = PasswordInput;

// NOTE: This string will be replaced on build time with the package version.
var version = "20.2.2";

exports["default"] = PasswordInput$1;
exports.version = version;
